\lstdefinelanguage{minizinc}{
    morekeywords={
        %% MiniZinc keywords
        %%
        ann, annotation, any, array, assert,
        bool,
        constraint,
        else, elseif, endif, enum, exists,
        float, forall, function,
        if, in, include, int,
        list,
        minimize, maximize,
        of, op, output,
        par, predicate,
        record,
        set, solve, string,
        test, then, tuple, type,
        var,
        where,  where, % needed with safe space in front at one place
        %% MiniZinc functions
        %%
        abort, abs, acosh, array_intersect, array_union,
        array1d, array2d, array3d, array4d, array5d, array6d, asin, assert, atan,
        bool2int,
        card, ceil, combinator, concat, cos, cosh,
        dom, dom_array, dom_size, dominance,
        exp,
        fix, floor,
        index_set, index_set_1of2, index_set_2of2, index_set_1of3, index_set_2of3, index_set_3of3,
        int2float, is_fixed,
        join,
        lb, lb_array, length, let, ln, log, log2, log10,
        min, max,
        pow, product,
        round,
        set2array, show, show_int, show_float, sin, sinh, sqrt, sum,
        tan, tanh, trace,
        ub, and ub_array,
        %% Search keywords
        %%
        bool_search, int_search, seq_search, priority_search,
        %% MiniSearch keywords
        %%
        minisearch, search, while, repeat, next, commit, print, post, sol, scope, time_limit, break, fail
    },
    sensitive=true, % are the keywords case sensitive
    morecomment=[l]{\%},
    %morecomment=[s]{/*}{*/},
    morestring=[b]",
    morestring=[b]',
    escapechar=@
}
\lstdefinelanguage{minibrass}[]{minizinc}{
    morekeywords={
		instantiates, with, params, offers, lex, pareto, new, PVSType,
    },
    otherkeywords={
        soft-constraint, PVS:, ->
    }
}
\lstdefinelanguage{qos2mzn}[]{minizinc}{
    morekeywords={
		ContractRanks
    },
    otherkeywords={
        requirement:, requirements:, provision:, provisions:, params:
    }
}
\lstdefinelanguage{qosagg}{
    morekeywords={
        workflow, graph, provision, for, aggregation, attribute, of, default, category, minizinc
    },
    sensitive=false,
    morecomment=[l]{\%},
    morestring=[b]",
    morestring=[b]',
    escapechar=@
}
\newcommand{\mzninline}[2][nolol]{\lstinline[language=minizinc, #1]{#2}}
\newcommand{\mzninputlisting}[2][nolol]{\lstinputlisting[language=minizinc, #1]{#2}}
\newcommand{\mbrinline}[2][nolol]{\lstinline[language=minibrass, #1]{#2}}
\newcommand{\mbrinputlisting}[2][nolol]{\lstinputlisting[language=minibrass, #1]{#2}}
\newcommand{\qosmzninline}[2][nolol]{\lstinline[language=qos2mzn, #1]{#2}}
\newcommand{\qosmzninputlisting}[2][nolol]{\lstinputlisting[language=qos2mzn, #1]{#2}}
\newcommand{\javainline}[2][nolol]{\lstinline[language=java, #1]#2}
\newcommand{\qosagginputlisting}[2][nolol]{\lstinputlisting[language=qosagg, #1]{#2}}
\newcommand{\qosagginline}[2][nolol]{\lstinline[language=qosagg, #1]{#2}}

\lstdefinelanguage{ANTLR}{
    morekeywords={options, grammar, tokens, lexer, import, fragment, parser},
    sensitive=true,
    morecomment=[l]{//},
    morecomment=[s]{/*}{*/},
    morestring=[b]',
    showstringspaces=false,
    escapechar=@
}

\lstset{
	basicstyle=\ttfamily,
    keywordstyle=\usebeamercolor[fg]{alerted text}\bfseries,
    stringstyle=\color{green!55!black},
    commentstyle=\color{red},
    %identifierstyle=\color{orange},
	breaklines=true,
    tabsize=2,
    extendedchars=true,
    inputencoding=utf8,
	frame=tb,
	numbers=left,
	numberstyle=\footnotesize\ttfamily,
    captionpos=b,
}

\renewcommand{\lstlistingnamestyle}{\usebeamercolor[fg]{caption name}\usebeamerfont{caption name}}